<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Base Types</TITLE>
<link href="suif1_62.html" rel=Next>
<link href="suif1_60.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_60.html">previous</A>, <A HREF="suif1_62.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC61" HREF="suif1_toc.html#TOC61">Base Types</A></H2>
<P>
<A NAME="IDX427"></A>
<A NAME="IDX428"></A>

</P>
<P>
<A NAME="IDX429"></A>
The <CODE>TYPE_VOID</CODE>, <CODE>TYPE_INT</CODE>, <CODE>TYPE_FLOAT</CODE>, and
<CODE>TYPE_ENUM</CODE> operators define the base types.  Whereas other kinds
of types are defined in terms of existing types, the base types stand
alone.  The <CODE>base_type</CODE> class is derived from <CODE>type_node</CODE> to
hold the base types.  It has only two fields: the size and a flag to
indicate whether integer and enumerated types are signed or unsigned.

</P>
<P>
<A NAME="IDX430"></A>
<A NAME="IDX431"></A>
<A NAME="IDX432"></A>
The <CODE>set_size</CODE> method sets the size of a base type in bits.  Types
with a <CODE>TYPE_VOID</CODE> operator should always have a size of zero.
Integer and floating-point types can have any sizes, although normally
the sizes are restricted by the target machine parameters (see section <A HREF="suif1_103.html#SEC103">Target Machine Parameters</A>).  Other sizes may cause the code generator to fail.
For integer and enumerated types, the <CODE>is_signed</CODE> method is used to
check the flag that indicates whether they are signed or unsigned.  The
<CODE>set_signed</CODE> method changes the value of the flag.

</P>
<P>
Besides the features that they share with the other base types,
enumerated types have other fields and methods used to record the names
and values of their members.  See section <A HREF="suif1_66.html#SEC66">Enumerated Types</A>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_60.html">previous</A>, <A HREF="suif1_62.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
